Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py	(revision 8253)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/parabolic_canal.py	(revision 8254)
@@ -107,5 +107,5 @@
     ztplot, = pylab.plot(x, z+t)
 
-    plot1.set_ylim([-1,40])
+    plot1.set_ylim([-1,50])
     pylab.xlabel('Position')
     pylab.ylabel('Stage')
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_comp_flux.c
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_comp_flux.c	(revision 8254)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_comp_flux.c	(revision 8254)
@@ -0,0 +1,61 @@
+#include "Python.h"
+#include "numpy/arrayobject.h"
+#include "math.h"
+#include <stdio.h>
+
+const double pi = 3.14159265358979;
+
+// Shared code snippets
+// Generic routines
+#include "util_ext.h"
+// Solver
+#include "solver.h"
+// Python-solver interface
+#include "python_solver.h"
+// square pipe solver implementation
+#include "sqpipe_default.h"
+// sqpipe-python glue
+#include "sqpipe_python.h"
+
+//=========================================================================
+// Python Glue
+//=========================================================================
+
+PyObject *compute_fluxes_ext(PyObject *self, PyObject *args) {
+  struct domain *D = (struct domain *) sqpipe_default_domain_new();
+  double timestep;
+  PyArrayObject *state;
+  PyObject *domain;
+
+  // Convert Python arguments to C
+  if (!PyArg_ParseTuple(args, "dO", &timestep, &domain)) {
+    PyErr_SetString(PyExc_RuntimeError, "comp_flux_ext.c: compute_fluxes_ext could not parse input");
+    return NULL;
+  }
+
+  D = (struct domain *) sqpipe_domain_python_get((struct sqpipe_domain *)D, domain, timestep);
+
+  // We need the state 
+  state = get_consecutive_array(domain, "state");
+  ((struct sqpipe_default_domain *)D)->state = (long *) state->data;
+
+  timestep = domain_compute_fluxes(D);
+  domain_destroy(D);
+  
+  return Py_BuildValue("d", timestep);
+}
+
+//-------------------------------
+// Method table for python module
+//-------------------------------
+
+static struct PyMethodDef MethodTable[] = {
+  {"compute_fluxes_ext", compute_fluxes_ext, METH_VARARGS, "Print out"},
+  {NULL, NULL}
+};
+
+// Module initialisation
+void initsqpipe_comp_flux(void){
+  Py_InitModule("sqpipe_comp_flux", MethodTable);
+  import_array();
+}
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_default.h
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_default.h	(revision 8254)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_default.h	(revision 8254)
@@ -0,0 +1,305 @@
+#include "sqpipe.h"
+
+/**********************************************************
+Square pipe default quantity class
+**********************************************************/
+
+struct sqpipe_default_quantity {
+  struct sqpipe_quantity super;
+  long state;
+};
+
+// Construction
+void sqpipe_default_quantity_init (struct sqpipe_default_quantity *q);
+struct sqpipe_default_quantity *sqpipe_default_quantity_new();
+
+// Destruction
+
+// Methods
+double* sqpipe_default_quantity_flux_formula (struct quantity *q, double normal, struct params *p, double *quantityflux);
+double sqpipe_default_quantity_sound_speed (struct quantity *q, struct params *p);
+double sqpipe_default_quantity_get_conserved (struct quantity *q, int k, double normal);
+
+// Implementation
+double* sqpipe_default_quantity_flux_formula (struct quantity *q, double normal, struct params *p, double *quantityflux) {
+  if (((struct sqpipe_default_quantity *)q)->state == 0) {
+    return sqpipe_quantity_free_surface_flux_formula(q, normal, p, quantityflux);
+  } else {
+    return sqpipe_quantity_pressurised_flux_formula(q, normal, p, quantityflux);
+  }
+}
+
+double sqpipe_default_quantity_sound_speed (struct quantity *q, struct params *p) {
+  if (((struct sqpipe_default_quantity *)q)->state == 0) {
+    return sqpipe_quantity_free_surface_sound_speed(q, p);
+  } else {
+    return sqpipe_quantity_pressurised_sound_speed(q, p);
+  }
+}
+
+double sqpipe_default_quantity_get_conserved (struct quantity *q, int k, double normal) {
+  struct sqpipe_quantity *p = (struct sqpipe_quantity*) q;
+  double c;
+  
+  switch (k) {
+  case 0:
+    c = p->a;
+    break;
+  case 1:
+    // This should be normal^2 p->d and normal is +/- 1
+    c = p->d;
+    break;
+  default:
+    c = 0;
+  }
+  return c;
+}
+
+void sqpipe_default_quantity_init (struct sqpipe_default_quantity *q) {
+  struct sqpipe_quantity *p = (struct sqpipe_quantity *)q;
+
+  sqpipe_quantity_init(p);
+
+  static struct quantity_vtable vtable = {
+    &sqpipe_default_quantity_flux_formula,
+    &sqpipe_default_quantity_sound_speed,
+    &sqpipe_default_quantity_get_conserved,
+    &sqpipe_quantity_destroy
+  };
+  p->super.vtable = &vtable;
+
+  ((struct sqpipe_default_quantity *)p)->state = 0;
+}
+
+struct sqpipe_default_quantity *sqpipe_default_quantity_new() {
+  struct sqpipe_default_quantity *p = malloc(sizeof(struct sqpipe_default_quantity));
+
+  sqpipe_default_quantity_init(p);
+
+  return p;
+}
+/**********************************************************/
+
+
+/**********************************************************
+Square pipe default edge class
+**********************************************************/
+struct sqpipe_default_edge {
+  struct sqpipe_edge super;
+};
+
+// Construction
+void sqpipe_default_edge_init (struct sqpipe_default_edge *e);
+struct sqpipe_default_edge *sqpipe_default_edge_new();
+
+// Destruction
+
+// Methods
+
+// Implementation
+
+void sqpipe_default_edge_init (struct sqpipe_default_edge *q) {
+  sqpipe_edge_init((struct sqpipe_edge *)q);
+}
+
+struct sqpipe_default_edge *sqpipe_default_edge_new() {
+  struct sqpipe_default_edge *e = (struct sqpipe_default_edge *) sqpipe_edge_new();
+
+  sqpipe_default_edge_init(e);
+
+  // Create inner and outer quantities
+  ((struct edge *)e)->qin = (struct quantity *)sqpipe_default_quantity_new();
+  ((struct edge *)e)->qout = (struct quantity *)sqpipe_default_quantity_new();
+  
+  return e;
+}
+/**********************************************************/
+
+
+/**********************************************************
+Square pipe default cell class
+**********************************************************/
+struct sqpipe_default_cell {
+  struct sqpipe_cell super;
+
+  long state;
+};
+
+// Construction
+void sqpipe_default_cell_init (struct sqpipe_default_cell *e);
+struct sqpipe_default_cell *sqpipe_default_cell_new();
+
+// Destruction
+
+// Methods
+double* sqpipe_default_cell_forcing_terms (struct cell *c, struct params *p, double *cellforce);
+
+// Implementation
+double* sqpipe_default_cell_forcing_terms (struct cell *c, struct params *p, double *cellforce) {
+  if (((struct sqpipe_default_cell *)c)->state == 0) {
+    return sqpipe_cell_free_surface_forcing_terms(c, p, cellforce);    
+  } else {
+    return sqpipe_cell_pressurised_forcing_terms(c, p, cellforce);
+  }
+}
+
+void sqpipe_default_cell_init (struct sqpipe_default_cell *q) {
+  struct sqpipe_cell *p = (struct sqpipe_cell *) q;
+
+  sqpipe_cell_init(p);
+
+  static struct cell_vtable vtable = {
+    &cell_flux_function_generic,
+    &sqpipe_cell_extreme_sound_speeds,
+    &sqpipe_default_cell_forcing_terms,
+    &sqpipe_cell_destroy
+  };
+  p->super.vtable = &vtable;
+
+  ((struct sqpipe_default_cell *)p)->state = 0;
+}
+
+struct sqpipe_default_cell *sqpipe_default_cell_new() {
+  int i;
+  struct sqpipe_default_cell *c = malloc(sizeof(struct sqpipe_default_cell));
+
+  // Allocate memory for a length 2 array of pointers to edges
+  ((struct cell *)c)->edges = (struct edge  **) malloc(2 * sizeof(struct sqpipe_edge *));
+
+  sqpipe_default_cell_init(c);
+
+  // Create edges
+  for (i=0; i<((struct cell *)c)->num_edges; i++) {
+    ((struct cell *)c)->edges[i] = (struct edge *) sqpipe_default_edge_new();
+  }
+
+  return c;
+}
+/**********************************************************/
+
+
+/**********************************************************
+Square pipe default quantities class
+**********************************************************/
+struct sqpipe_default_quantities {
+  struct sqpipe_quantities super;
+};
+
+// Construction
+void sqpipe_default_quantities_init (struct sqpipe_default_quantities *q);
+struct sqpipe_default_quantities *sqpipe_default_quantities_new();
+
+// Destruction
+
+// Methods
+void sqpipe_default_quantities_update (struct quantities *qs, double *flux, int k);
+
+
+// Implementation
+void sqpipe_default_quantities_update (struct quantities *qs, double *flux, int k) {
+  struct sqpipe_quantities *ps = (struct sqpipe_quantities *) qs;
+  ps->a[k] = flux[0];
+  ps->d[k] = flux[1];
+}
+
+void sqpipe_default_quantities_init (struct sqpipe_default_quantities *q) {
+  struct sqpipe_quantities *p = (struct sqpipe_quantities *)q;
+
+  sqpipe_quantities_init(p);
+
+  static struct quantities_vtable vtable = {
+    &sqpipe_quantities_get_quantity,
+    &sqpipe_default_quantities_update,
+    &sqpipe_quantities_destroy
+  };
+  p->super.vtable = &vtable;
+}
+
+struct sqpipe_default_quantities *sqpipe_default_quantities_new() {
+  struct sqpipe_default_quantities *p = (struct sqpipe_default_quantities *) sqpipe_quantities_new();
+
+  sqpipe_default_quantities_init(p);
+
+  return p;
+}
+/**********************************************************/
+
+
+/**********************************************************
+Square pipe default domain class
+**********************************************************/
+
+struct sqpipe_default_domain {
+  struct sqpipe_domain super;
+  long *state;
+};
+
+// Construction
+void sqpipe_default_domain_init (struct sqpipe_default_domain *d);
+struct sqpipe_default_domain *sqpipe_default_domain_new();
+
+// Destruction
+
+// Methods
+struct edge* sqpipe_default_domain_new_edge(struct domain *d);
+struct cell* sqpipe_default_domain_new_cell(struct domain *d);
+struct cell* sqpipe_default_domain_get_cell(struct domain *D, int k, struct cell *c);
+
+// Implementation
+struct edge* sqpipe_default_domain_new_edge(struct domain *d) {
+  struct edge *e = (struct edge*) sqpipe_default_edge_new();
+
+  return e;
+}
+
+struct cell* sqpipe_default_domain_new_cell(struct domain *d) {
+  struct cell *c = (struct cell*) sqpipe_default_cell_new();
+  return c;
+}
+
+struct cell* sqpipe_default_domain_get_cell(struct domain *D, int k, struct cell *c) {
+  struct sqpipe_default_cell *sc = (struct sqpipe_default_cell *) c;
+  struct sqpipe_default_domain *sD = (struct sqpipe_default_domain *) D;
+  int i;
+  
+  c = domain_get_cell_generic(D, k, c);
+
+  // Set state
+  sc->state = sD->state[k];
+  for (i = 0; i<c->num_edges; i++) {
+    ((struct sqpipe_default_quantity *)(c->edges[i]->qin))->state = sc->state;
+    ((struct sqpipe_default_quantity *)(c->edges[i]->qout))->state = sc->state;
+  }
+  
+  return c;
+}
+
+void sqpipe_default_domain_init (struct sqpipe_default_domain *d) {
+  struct sqpipe_domain *p = (struct sqpipe_domain *)d;
+
+  sqpipe_domain_init(p);
+
+  static struct domain_vtable vtable = {
+    &sqpipe_default_domain_new_edge,
+    &sqpipe_default_domain_new_cell,
+    &domain_compute_fluxes_generic,
+    &sqpipe_default_domain_get_cell,
+    &sqpipe_domain_destroy
+  };
+  p->super.vtable = &vtable;
+
+  ((struct sqpipe_default_domain *)p)->state = NULL;
+}
+
+struct sqpipe_default_domain *sqpipe_default_domain_new() {
+  struct sqpipe_default_domain *d = (struct sqpipe_default_domain *) sqpipe_domain_new();
+
+  sqpipe_default_domain_init(d);
+
+  ((struct domain *) d)->vertex_values = (struct quantities *) sqpipe_default_quantities_new();
+  ((struct domain *) d)->boundary_values = (struct quantities *) sqpipe_default_quantities_new();
+  ((struct domain *) d)->explicit_update = (struct quantities *) sqpipe_default_quantities_new();
+
+  return d;
+}
+/**********************************************************/
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py	(revision 8253)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/sqpipe_domain.py	(revision 8254)
@@ -46,10 +46,12 @@
 
 from anuga_1d.base.generic_domain import Generic_domain
+from anuga_1d.sqpipe.sqpipe_forcing_terms import *
+from anuga_1d.sqpipe.sqpipe_boundary_conditions import *
 
 #Shallow water domain
-class Sqpipe_domain(Generic_domain):
-
-    def __init__(self, coordinates, conserved_quantities, forcing_terms = [], boundary = None, state = None, update_state_flag = True, bulk_modulus = 1.0, tagged_elements = None):
-
+class Domain(Generic_domain):
+
+    def __init__(self, coordinates, boundary = None, forcing_terms = [], state = None, update_state_flag = True, bulk_modulus = 1.0, tagged_elements = None):
+        conserved_quantities = ['area', 'discharge']
         evolved_quantities = ['area', 'discharge', 'elevation', 'height', 'velocity','width','top','stage']
         other_quantities = ['friction']
@@ -149,5 +151,5 @@
 
         # Import flux method and call it
-        from anuga_1d.sqpipe.sqpipe_dual_fixed_width_a_d_comp_flux import compute_fluxes_ext
+        from anuga_1d.sqpipe.sqpipe_comp_flux import compute_fluxes_ext
  	self.flux_timestep = compute_fluxes_ext(timestep,self)        
 
@@ -171,6 +173,83 @@
 
     def distribute_to_vertices_and_edges(self):
-        # Should be implemented by the derived class
-        raise Exception("Not implemented")
+        # Shortcuts
+        h0 = self.h0
+        epsilon = self.epsilon
+
+        area      = self.quantities['area']
+        discharge = self.quantities['discharge']
+        bed       = self.quantities['elevation']
+        height    = self.quantities['height']
+        velocity  = self.quantities['velocity']
+        width     = self.quantities['width']
+        top       = self.quantities['top']
+        stage     = self.quantities['stage']
+
+        #Arrays   
+        a_C   = area.centroid_values
+        d_C   = discharge.centroid_values
+        z_C   = bed.centroid_values
+        h_C   = height.centroid_values
+        u_C   = velocity.centroid_values
+        b_C   = width.centroid_values
+        t_C   = top.centroid_values
+        w_C   = stage.centroid_values
+
+        #Calculate height (and fix negatives)better be non-negative!
+        h_C[:] = a_C/(b_C + h0/(b_C + h0)) # Do we need to protect against small b? Make a b0 instead of h0 or use epsilon?
+        w_C[:] = z_C + h_C
+        u_C[:]  = d_C/(h_C + h0/(h_C + h0))
+
+        for name in ['velocity', 'stage' ]:
+            Q = self.quantities[name]
+            if self.order == 1:
+                Q.extrapolate_first_order()
+            elif self.order == 2:
+                Q.extrapolate_second_order()
+            else:
+                raise 'Unknown order'
+
+        # These have been extrapolated
+        w_V = self.quantities['stage'].vertex_values
+        u_V = self.quantities['velocity'].vertex_values
+
+        # These are the given geometry and remain fixed
+        z_V  = bed.vertex_values
+        b_V  = width.vertex_values
+        t_V  = top.vertex_values
+
+        # These need to be updated
+        a_V  = area.vertex_values
+        d_V  = discharge.vertex_values
+        h_V  = height.vertex_values
+
+        h_V[:,:]    = w_V - z_V
+
+        # Fix up small heights
+        h_0 = numpy.where(h_V[:,0] < 0.0, 0.0, h_V[:,0])
+        h_1 = numpy.where(h_V[:,0] < 0.0, h_V[:,1]+h_V[:,0], h_V[:,1])
+
+        h_V[:,0] = h_0
+        h_V[:,1] = h_1
+
+        h_0 = numpy.where(h_V[:,1] < 0.0, h_V[:,1]+h_V[:,0], h_V[:,0])
+        h_1 = numpy.where(h_V[:,1] < 0.0, 0.0, h_V[:,1])
+
+        h_V[:,0] = h_0
+        h_V[:,1] = h_1
+
+        # It may still be possible that h is small 
+        # If we set h to zero, we should also set u to 0
+        h_V[:,:] = numpy.where(h_V < epsilon, 0.0, h_V)
+        u_V[:,:] = numpy.where(h_V < epsilon, 0.0, u_V)
+
+        # Reconstruct conserved quantities and make everything consistent
+        # with new h values
+        w_V[:,:] = z_V + h_V
+        a_V[:,:] = h_V * b_V
+        d_V[:,:] = u_V * a_V
+
+
+        return
         
     def evolve(self, yieldstep = None, finaltime = None, duration = None,
Index: /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py
===================================================================
--- /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py	(revision 8253)
+++ /trunk/anuga_work/development/2010-projects/anuga_1d/sqpipe/test_sqpipe_domain.py	(revision 8254)
@@ -1,5 +1,5 @@
 import anuga_1d.sqpipe.parabolic_canal
 import time
-import anuga_1d.sqpipe.sqpipe_test_domain as dom
+import anuga_1d.sqpipe.sqpipe_domain as dom
 
 
